unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls;

type
  TForm1 = class(TForm)
    tv1: TTreeView;
    lv1: TListView;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure mFillTreeLevel(oParentNode: TTreeNode; const sPath:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  lvItem: TListItem;
  i: Integer;
  tvItem: TTreeNode;
  j: Integer;
const
  csStart = 'c:\Windows\System32';
begin
  tv1.Items.BeginUpdate;
//  mFillTreeLevel(nil, 'c:');
  mFillTreeLevel(tv1.Items.Add(nil, csStart), csStart );
  tv1.Items.EndUpdate;
end;

procedure TForm1.mFillTreeLevel(oParentNode: TTreeNode; const sPath: string);
var
  sr: TSearchRec;
  oItem: TTreeNode;

begin
  if FindFirst(sPath+'\'+'*.*', faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Attr and faDirectory) > 0 then
      begin
        if (sr.name <> '.') and (sr.Name <> '..') then
        begin
          oItem := tv1.Items.AddChild(oParentNode, sr.Name);
          mFillTreeLevel(oItem, sPath + '\'+sr.Name );
        end;
      end;
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);
end;

end.
